diff --git a/gdb/frame-info.c b/gdb/frame-info.c
index d61fb7ed0e95..8ab5f54f8202 100644
--- a/gdb/frame-info.c
+++ b/gdb/frame-info.c
@@ -31,14 +31,19 @@ intrusive_list<frame_info_ptr> frame_info_ptr::frame_list;
 
 /* See frame-info-ptr.h.  */
 
-void
-frame_info_ptr::prepare_reinflate ()
+frame_info_ptr::frame_info_ptr (struct frame_info *ptr)
+  : m_ptr (ptr)
 {
-  m_cached_level = frame_relative_level (*this);
+  frame_list.push_back (*this);
 
-  if (m_cached_level != 0
-      || (m_ptr != nullptr && frame_is_user_created (m_ptr)))
-    m_cached_id = get_frame_id (*this);
+  if (m_ptr != nullptr)
+    {
+      m_cached_level = frame_relative_level (m_ptr);
+
+      if (m_cached_level != 0
+	  || (m_ptr != nullptr && frame_is_user_created (m_ptr)))
+	m_cached_id = get_frame_id (m_ptr);
+    }
 }
 
 /* See frame-info-ptr.h.  */
@@ -91,7 +96,6 @@ test_user_created_frame ()
   SELF_CHECK (id.code_addr_p);
   SELF_CHECK (id.code_addr == 0x5678);
 
-  frame.prepare_reinflate ();
   reinit_frame_cache ();
   frame.reinflate ();
 
diff --git a/gdb/frame-info.h b/gdb/frame-info.h
index 8f01ee007914..224a553ac040 100644
--- a/gdb/frame-info.h
+++ b/gdb/frame-info.h
@@ -38,11 +38,7 @@ class frame_info_ptr : public intrusive_list_node<frame_info_ptr>
 {
 public:
   /* Create a frame_info_ptr from a raw pointer.  */
-  explicit frame_info_ptr (struct frame_info *ptr)
-    : m_ptr (ptr)
-  {
-    frame_list.push_back (*this);
-  }
+  explicit frame_info_ptr (struct frame_info *ptr);
 
   /* Create a null frame_info_ptr.  */
   frame_info_ptr ()
@@ -142,9 +138,6 @@ class frame_info_ptr : public intrusive_list_node<frame_info_ptr>
     m_ptr = nullptr;
   }
 
-  /* Cache the frame_id that the pointer will use to reinflate.  */
-  void prepare_reinflate ();
-
   /* Use the cached frame_id to reinflate the pointer.  */
   void reinflate ();
 
diff --git a/gdb/infcmd.c b/gdb/infcmd.c
index a27d3577b3aa..ee3d97b585dd 100644
--- a/gdb/infcmd.c
+++ b/gdb/infcmd.c
@@ -1837,7 +1837,6 @@ finish_command (const char *arg, int from_tty)
   frame = get_prev_frame (get_selected_frame (_("No selected frame.")));
   if (frame == 0)
     error (_("\"finish\" not meaningful in the outermost frame."));
-  frame.prepare_reinflate ();
 
   clear_proceed_status (0);
 
diff --git a/gdb/mi/mi-cmd-stack.c b/gdb/mi/mi-cmd-stack.c
index f0af7c9a0143..186d53156730 100644
--- a/gdb/mi/mi-cmd-stack.c
+++ b/gdb/mi/mi-cmd-stack.c
@@ -176,7 +176,6 @@ mi_cmd_stack_list_frames (const char *command, char **argv, int argc)
 	   i++, fi = get_prev_frame (fi))
 	{
 	  QUIT;
-	  fi.prepare_reinflate ();
 	  /* Print the location and the address always, even for level 0.
 	     If args is 0, don't print the arguments.  */
 	  print_frame_info (user_frame_print_options,
diff --git a/gdb/stack.c b/gdb/stack.c
index 4ad51c2eb50e..126ce0b8cc2a 100644
--- a/gdb/stack.c
+++ b/gdb/stack.c
@@ -362,7 +362,6 @@ print_stack_frame (frame_info_ptr frame, int print_level,
   if (current_uiout->is_mi_like_p ())
     print_what = LOC_AND_ADDRESS;
 
-  frame.prepare_reinflate ();
   try
     {
       print_frame_info (user_frame_print_options,
@@ -744,11 +743,6 @@ print_frame_args (const frame_print_options &fp_opts,
     = (print_names
        && fp_opts.print_frame_arguments != print_frame_arguments_none);
 
-  /* If one of the arguments has a pretty printer that calls a
-     function of the inferior to print it, the pointer must be
-     reinflatable.  */
-  frame.prepare_reinflate ();
-
   /* Temporarily change the selected frame to the given FRAME.
      This allows routines that rely on the selected frame instead
      of being given a frame as parameter to use the correct frame.  */
@@ -1047,8 +1041,6 @@ print_frame_info (const frame_print_options &fp_opts,
   int location_print;
   struct ui_out *uiout = current_uiout;
 
-  frame.prepare_reinflate ();
-
   if (!current_uiout->is_mi_like_p ()
       && fp_opts.print_frame_info != print_frame_info_auto)
     {
@@ -1682,7 +1674,6 @@ info_frame_command_core (frame_info_ptr fi, bool selected_frame_p)
 	      gdb_printf (" %d args: ", numargs);
 	  }
 
-	fi.prepare_reinflate ();
 	print_frame_args (user_frame_print_options,
 			  func, fi, numargs, gdb_stdout);
 	fi.reinflate ();
@@ -2075,7 +2066,6 @@ backtrace_command_1 (const frame_print_options &fp_opts,
       for (fi = trailing; fi && count--; fi = get_prev_frame (fi))
 	{
 	  QUIT;
-	  fi.prepare_reinflate ();
 
 	  /* Don't use print_stack_frame; if an error() occurs it probably
 	     means further attempts to backtrace would fail (on the other